<script>
  export let route
  export let title

  import QRious from 'qrious'
  import { onMount } from 'svelte'

  import LoadingBox from '../components/LoadingBox'
  import Error from '../components/Error'

  import groups from '../stores/groups'

  import getGroupAuth from '../utils/getGroupAuth'

  $: groupId = parseInt(route.matches[1])
  $: group = $groups[groupId]
  $: $title = group ? 'Invitar a ' + group.name : 'Invitar'

  $: refresh(groupId)

  let auth

  let loading = true
  let error
  function refresh() {
    loading = true
    error = null
    getGroupAuth(groupId)
      .then(_auth => (auth = _auth))
      .then(auth => getGroup(auth.id, auth.secret))
      .then(() => {
        generateQr()
        return auth
      })
      .catch(e => (error = e))
      .finally(() => (loading = false))
  }

  $: url = auth && location.origin + '/#/join/' + auth.id + ',' + auth.secret

  // qr code generation
  let canvasEl
  function generateQr() {
    if (!auth) return
    new QRious({
      element: canvasEl,
      value: url,
      size: 800,
    })
  }
  onMount(generateQr)
  $: canvasEl && generateQr(url)
</script>

{#if group}
  <div class="max-w-xl mx-auto p-2 text-xl text-center">
    <canvas class="w-full max-w-lg mx-auto" bind:this={canvasEl} />
    <p class="my-2 font-semibold">
      Escanea este código QR con el celular para unirse a el grupo.
    </p>
    <p class="my-2">Tambíen podés compartir este link:</p>
    <input
      class="input text-lg"
      on:click={e => e.target.select()}
      readonly
      value={url}
    />
  </div>
{:else if loading}
  <LoadingBox />
{/if}

{#if !group && error}
  <div class="p-2 m-auto m-full max-w-lg">
    <Error {error} />
    <div class="p-2">
      <p class="p-2 text-center">Se volvera a intentar en 30 segundos.</p>
      <button class="btn btn-blue m-auto block" on:click={refresh}>
        Reintentar ahora
      </button>
    </div>
  </div>
{/if}
